package sunspider.jaxws20.tutorial.client;

import junit.framework.TestCase;
import jboss.wsconsume.gen.hotelbooking.stub.*;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.Future;
import java.util.concurrent.TimeUnit;

import javax.xml.namespace.QName;
import javax.xml.ws.AsyncHandler;
import javax.xml.ws.Response;
import javax.xml.ws.Service;


public class TestJAXWS20DynaClient extends TestCase {
	private HotelBookingService endPoint;
	private String targetNS="file:///E:/files/jBossProject/JAX-WS2.0/resource/hotelbooking.wsdl";
	private String targetEndPoint="http://sunspider.tutorial.com.cn/jaxws20/2008/ws";
	private String targetService="bookingService";
	
	List<Address> adds=new ArrayList<Address>();
	
	Order o=new Order();
	{
		
		Address address1=new Address();
		address1.setCountry("china");
		address1.setEmail("vondart@ddd.cn");
		Address address2=new Address();
		address2.setCountry("usa");
		address2.setEmail("vondart@ddd.com");
		adds.add(address1);
		adds.add(address2);
		List<OrderItem> ords=new ArrayList<OrderItem>();
		OrderItem oi1=new OrderItem();
		oi1.setName("pizza");
		oi1.setNumber(2);
		oi1.setOrderType(OrderType.BUSINESS_ROOM);
		oi1.getAddressInput().add(adds.get(0));
		OrderItem oi2=new OrderItem();
		oi2.setName("pudding");
		oi2.setNumber(3);
		oi2.setOrderType(OrderType.ROYAL_ROOM);
		oi2.getAddressInput().addAll(adds);
		
		o.setClientID("diidek-99");
		o.getOrderInputs().add(oi1);
		o.getOrderInputs().add(oi2);
	}
	@Override
	protected void setUp() throws Exception {
		// TODO Auto-generated method stub
		Service service=Service.create(new URL(targetNS), new QName(targetEndPoint,targetService));
		endPoint=service.getPort(HotelBookingService.class);
	}
	
	public static void main(String[] args) {
		TestJAXWS20DynaClient c=new TestJAXWS20DynaClient();
		try {
			c.setUp();
			c.testBookingAsync();
//			c.testBookingAsyncHandler();
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		
	}
	public void testBookingAsync()
	{
		
		Response<BookingOperationResponse> response=endPoint.bookingOperationAsync(o);
		while(!response.isDone())
		{
			System.out.println("not done");
			try {
				Thread.currentThread().sleep(100);
			} catch (Exception e) {
				// TODO: handle exception
				e.printStackTrace();
			}
			
		}
		System.out.println("done");
		hanldeResponse1(response);
		
	}
	private void hanldeResponse1(Response<BookingOperationResponse> response) {
		try {
//			Tickets ticket=
				response.get().getReservedTickets();
//			System.out.println(ticket.getClietnID());
//			System.out.println(ticket.getTotalPrice());
//			
//			for(Address add:ticket.getAddressOutput())
//			{
//				System.out.println(add.getCountry()+","+add.getEmail());
//			}
//			System.out.println(response);
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
	}
	public void testBookingAsyncHandler()
	{
		AsyncHandler handler=new AsyncHandler(){
			public void handleResponse(Response response)
			{
				hanldeResponse1(response);
			}
		};
		endPoint.bookingOperationAsync(o, handler);
	}
	@Override
	protected void tearDown() throws Exception {
		// TODO Auto-generated method stub
		System.out.println("Tear Down");
	}

}
