package sunspider.jaxws20.tutorial.client;

import junit.framework.TestCase;
import jboss.wsconsume.gen.hotelbooking.stub.*;
import java.net.URL;
import javax.xml.namespace.QName;
import javax.xml.ws.Holder;

import java.util.List;
import java.util.ArrayList;


public class TestJAXWS20stub extends TestCase {
	private String wsdlLocation="http://192.168.1.122:8080/hotelBooking/hotelbooking?wsdl";
	private String targetNS="http://sunspider.tutorial.com.cn/jaxws20/2008/ws";
	private String serviceNS="bookingService";
	HotelBookingService stub;
	List<Address> adds=new ArrayList<Address>();
	{
		Address address1=new Address();
		address1.setCountry("china");
		address1.setEmail("vondart@ddd.cn");
		Address address2=new Address();
		address2.setCountry("usa");
		address2.setEmail("vondart@ddd.com");
		adds.add(address1);
		adds.add(address2);
	try {
		BookingService service=new BookingService(new URL(wsdlLocation),new QName(targetNS,serviceNS));
		stub=service.getHotelBookingPort();
	} catch (Exception e) {
		// TODO: handle exception
		e.printStackTrace();
	}	
	}
	@Override
	protected void setUp() throws Exception {
		// TODO Auto-generated method stub
		System.out.println("SetUp");
		
	}
	public static void main(String[] args) {
		TestJAXWS20stub ts=new TestJAXWS20stub();
		try {
			ts.setUp();
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		ts.testRegister();
	}
public void testRegister()
{
	
	
	
	String response=stub.registerOperation(adds.get(0));
	System.out.println(response);
	
}
public void testBooking()
{
	List<OrderItem> ords=new ArrayList<OrderItem>();
	OrderItem oi1=new OrderItem();
	oi1.setName("pizza");
	oi1.setNumber(2);
	oi1.setOrderType(OrderType.BUSINESS_ROOM);
	oi1.getAddressInput().add(adds.get(0));
	OrderItem oi2=new OrderItem();
	oi2.setName("pudding");
	oi2.setNumber(3);
	oi2.setOrderType(OrderType.ROYAL_ROOM);
	oi2.getAddressInput().addAll(adds);
	Order o=new Order();
	o.setClientID("diidek-99");
	o.getOrderInputs().add(oi1);
	o.getOrderInputs().add(oi2);
	Tickets t=stub.bookingOperation(o);
	System.out.println(t.getClietnID()+","+t.getTotalPrice());
	for(Address a:t.getAddressOutput())
	{
		System.out.println(a.getCountry()+","+a.getEmail());
	}
	
}
	@Override
	protected void tearDown() throws Exception {
		// TODO Auto-generated method stub
		
		System.out.println("TearDown");
	}

}
